/* matrix6.c
 * Functions for manipulating 6 × 6 matrices.
 * 
 * Generated by the matgen.pl script version 0.9 on 2009-10-10.
 * This generated code is not copyrighted since it is the result of a 
 * purely mechanical transformation, and free for anyone to use.
 *
 * The matgen.pl script is © 2009 R.F. Smith <rsmith@xs4all.nl>
 */

#include <assert.h>
#include <stdio.h>
#include <string.h>
#include "matrix6.h"

#ifndef NULL
#define NULL (void*)0
#endif

/* If the product of the multiplication of two doubles is less than EPS,
 * the value is set to 0. */
#define EPS 1e-8

void mat_unity6(double a[6][6])
{
	assert(a!=NULL);
	/*  Row 0 */
	a[0][0] = 1.0;
	a[0][1] = 0.0;
	a[0][2] = 0.0;
	a[0][3] = 0.0;
	a[0][4] = 0.0;
	a[0][5] = 0.0;
	/*  Row 1 */
	a[1][0] = 0.0;
	a[1][1] = 1.0;
	a[1][2] = 0.0;
	a[1][3] = 0.0;
	a[1][4] = 0.0;
	a[1][5] = 0.0;
	/*  Row 2 */
	a[2][0] = 0.0;
	a[2][1] = 0.0;
	a[2][2] = 1.0;
	a[2][3] = 0.0;
	a[2][4] = 0.0;
	a[2][5] = 0.0;
	/*  Row 3 */
	a[3][0] = 0.0;
	a[3][1] = 0.0;
	a[3][2] = 0.0;
	a[3][3] = 1.0;
	a[3][4] = 0.0;
	a[3][5] = 0.0;
	/*  Row 4 */
	a[4][0] = 0.0;
	a[4][1] = 0.0;
	a[4][2] = 0.0;
	a[4][3] = 0.0;
	a[4][4] = 1.0;
	a[4][5] = 0.0;
	/*  Row 5 */
	a[5][0] = 0.0;
	a[5][1] = 0.0;
	a[5][2] = 0.0;
	a[5][3] = 0.0;
	a[5][4] = 0.0;
	a[5][5] = 1.0;
}

void mat_cpy6(double a[6][6], double b[6][6])
{
	assert(a!=NULL); assert(b!=NULL);
	/*  Row 0 */
	b[0][0] = a[0][0];
	b[0][1] = a[0][1];
	b[0][2] = a[0][2];
	b[0][3] = a[0][3];
	b[0][4] = a[0][4];
	b[0][5] = a[0][5];
	/*  Row 1 */
	b[1][0] = a[1][0];
	b[1][1] = a[1][1];
	b[1][2] = a[1][2];
	b[1][3] = a[1][3];
	b[1][4] = a[1][4];
	b[1][5] = a[1][5];
	/*  Row 2 */
	b[2][0] = a[2][0];
	b[2][1] = a[2][1];
	b[2][2] = a[2][2];
	b[2][3] = a[2][3];
	b[2][4] = a[2][4];
	b[2][5] = a[2][5];
	/*  Row 3 */
	b[3][0] = a[3][0];
	b[3][1] = a[3][1];
	b[3][2] = a[3][2];
	b[3][3] = a[3][3];
	b[3][4] = a[3][4];
	b[3][5] = a[3][5];
	/*  Row 4 */
	b[4][0] = a[4][0];
	b[4][1] = a[4][1];
	b[4][2] = a[4][2];
	b[4][3] = a[4][3];
	b[4][4] = a[4][4];
	b[4][5] = a[4][5];
	/*  Row 5 */
	b[5][0] = a[5][0];
	b[5][1] = a[5][1];
	b[5][2] = a[5][2];
	b[5][3] = a[5][3];
	b[5][4] = a[5][4];
	b[5][5] = a[5][5];
}

void mat_xform6(double m[6][6], double v[6], double mv[6])
{
	double res[6];
	assert(m!=NULL); assert(v!=NULL); assert(mv!=NULL);
	res[0]  = m[0][0]*v[0];
	res[0] += m[0][1]*v[1];
	res[0] += m[0][2]*v[2];
	res[0] += m[0][3]*v[3];
	res[0] += m[0][4]*v[4];
	res[0] += m[0][5]*v[5];
	res[1]  = m[1][0]*v[0];
	res[1] += m[1][1]*v[1];
	res[1] += m[1][2]*v[2];
	res[1] += m[1][3]*v[3];
	res[1] += m[1][4]*v[4];
	res[1] += m[1][5]*v[5];
	res[2]  = m[2][0]*v[0];
	res[2] += m[2][1]*v[1];
	res[2] += m[2][2]*v[2];
	res[2] += m[2][3]*v[3];
	res[2] += m[2][4]*v[4];
	res[2] += m[2][5]*v[5];
	res[3]  = m[3][0]*v[0];
	res[3] += m[3][1]*v[1];
	res[3] += m[3][2]*v[2];
	res[3] += m[3][3]*v[3];
	res[3] += m[3][4]*v[4];
	res[3] += m[3][5]*v[5];
	res[4]  = m[4][0]*v[0];
	res[4] += m[4][1]*v[1];
	res[4] += m[4][2]*v[2];
	res[4] += m[4][3]*v[3];
	res[4] += m[4][4]*v[4];
	res[4] += m[4][5]*v[5];
	res[5]  = m[5][0]*v[0];
	res[5] += m[5][1]*v[1];
	res[5] += m[5][2]*v[2];
	res[5] += m[5][3]*v[3];
	res[5] += m[5][4]*v[4];
	res[5] += m[5][5]*v[5];
	memcpy(mv, res, 6*sizeof(double));
}

void mat_mul6(double a[6][6], double b[6][6], double ab[6][6])
{
	double res[6][6];
	assert(a!=NULL); assert(b!=NULL); assert(ab!=NULL);
	res[0][0]  = a[0][0]*b[0][0];
	res[0][0] += a[0][1]*b[1][0];
	res[0][0] += a[0][2]*b[2][0];
	res[0][0] += a[0][3]*b[3][0];
	res[0][0] += a[0][4]*b[4][0];
	res[0][0] += a[0][5]*b[5][0];
	if (res[0][0] < EPS && res[0][0] > -EPS) {res[0][0] = 0.0;}
	res[0][1]  = a[0][0]*b[0][1];
	res[0][1] += a[0][1]*b[1][1];
	res[0][1] += a[0][2]*b[2][1];
	res[0][1] += a[0][3]*b[3][1];
	res[0][1] += a[0][4]*b[4][1];
	res[0][1] += a[0][5]*b[5][1];
	if (res[0][1] < EPS && res[0][1] > -EPS) {res[0][1] = 0.0;}
	res[0][2]  = a[0][0]*b[0][2];
	res[0][2] += a[0][1]*b[1][2];
	res[0][2] += a[0][2]*b[2][2];
	res[0][2] += a[0][3]*b[3][2];
	res[0][2] += a[0][4]*b[4][2];
	res[0][2] += a[0][5]*b[5][2];
	if (res[0][2] < EPS && res[0][2] > -EPS) {res[0][2] = 0.0;}
	res[0][3]  = a[0][0]*b[0][3];
	res[0][3] += a[0][1]*b[1][3];
	res[0][3] += a[0][2]*b[2][3];
	res[0][3] += a[0][3]*b[3][3];
	res[0][3] += a[0][4]*b[4][3];
	res[0][3] += a[0][5]*b[5][3];
	if (res[0][3] < EPS && res[0][3] > -EPS) {res[0][3] = 0.0;}
	res[0][4]  = a[0][0]*b[0][4];
	res[0][4] += a[0][1]*b[1][4];
	res[0][4] += a[0][2]*b[2][4];
	res[0][4] += a[0][3]*b[3][4];
	res[0][4] += a[0][4]*b[4][4];
	res[0][4] += a[0][5]*b[5][4];
	if (res[0][4] < EPS && res[0][4] > -EPS) {res[0][4] = 0.0;}
	res[0][5]  = a[0][0]*b[0][5];
	res[0][5] += a[0][1]*b[1][5];
	res[0][5] += a[0][2]*b[2][5];
	res[0][5] += a[0][3]*b[3][5];
	res[0][5] += a[0][4]*b[4][5];
	res[0][5] += a[0][5]*b[5][5];
	if (res[0][5] < EPS && res[0][5] > -EPS) {res[0][5] = 0.0;}
	res[1][0]  = a[1][0]*b[0][0];
	res[1][0] += a[1][1]*b[1][0];
	res[1][0] += a[1][2]*b[2][0];
	res[1][0] += a[1][3]*b[3][0];
	res[1][0] += a[1][4]*b[4][0];
	res[1][0] += a[1][5]*b[5][0];
	if (res[1][0] < EPS && res[1][0] > -EPS) {res[1][0] = 0.0;}
	res[1][1]  = a[1][0]*b[0][1];
	res[1][1] += a[1][1]*b[1][1];
	res[1][1] += a[1][2]*b[2][1];
	res[1][1] += a[1][3]*b[3][1];
	res[1][1] += a[1][4]*b[4][1];
	res[1][1] += a[1][5]*b[5][1];
	if (res[1][1] < EPS && res[1][1] > -EPS) {res[1][1] = 0.0;}
	res[1][2]  = a[1][0]*b[0][2];
	res[1][2] += a[1][1]*b[1][2];
	res[1][2] += a[1][2]*b[2][2];
	res[1][2] += a[1][3]*b[3][2];
	res[1][2] += a[1][4]*b[4][2];
	res[1][2] += a[1][5]*b[5][2];
	if (res[1][2] < EPS && res[1][2] > -EPS) {res[1][2] = 0.0;}
	res[1][3]  = a[1][0]*b[0][3];
	res[1][3] += a[1][1]*b[1][3];
	res[1][3] += a[1][2]*b[2][3];
	res[1][3] += a[1][3]*b[3][3];
	res[1][3] += a[1][4]*b[4][3];
	res[1][3] += a[1][5]*b[5][3];
	if (res[1][3] < EPS && res[1][3] > -EPS) {res[1][3] = 0.0;}
	res[1][4]  = a[1][0]*b[0][4];
	res[1][4] += a[1][1]*b[1][4];
	res[1][4] += a[1][2]*b[2][4];
	res[1][4] += a[1][3]*b[3][4];
	res[1][4] += a[1][4]*b[4][4];
	res[1][4] += a[1][5]*b[5][4];
	if (res[1][4] < EPS && res[1][4] > -EPS) {res[1][4] = 0.0;}
	res[1][5]  = a[1][0]*b[0][5];
	res[1][5] += a[1][1]*b[1][5];
	res[1][5] += a[1][2]*b[2][5];
	res[1][5] += a[1][3]*b[3][5];
	res[1][5] += a[1][4]*b[4][5];
	res[1][5] += a[1][5]*b[5][5];
	if (res[1][5] < EPS && res[1][5] > -EPS) {res[1][5] = 0.0;}
	res[2][0]  = a[2][0]*b[0][0];
	res[2][0] += a[2][1]*b[1][0];
	res[2][0] += a[2][2]*b[2][0];
	res[2][0] += a[2][3]*b[3][0];
	res[2][0] += a[2][4]*b[4][0];
	res[2][0] += a[2][5]*b[5][0];
	if (res[2][0] < EPS && res[2][0] > -EPS) {res[2][0] = 0.0;}
	res[2][1]  = a[2][0]*b[0][1];
	res[2][1] += a[2][1]*b[1][1];
	res[2][1] += a[2][2]*b[2][1];
	res[2][1] += a[2][3]*b[3][1];
	res[2][1] += a[2][4]*b[4][1];
	res[2][1] += a[2][5]*b[5][1];
	if (res[2][1] < EPS && res[2][1] > -EPS) {res[2][1] = 0.0;}
	res[2][2]  = a[2][0]*b[0][2];
	res[2][2] += a[2][1]*b[1][2];
	res[2][2] += a[2][2]*b[2][2];
	res[2][2] += a[2][3]*b[3][2];
	res[2][2] += a[2][4]*b[4][2];
	res[2][2] += a[2][5]*b[5][2];
	if (res[2][2] < EPS && res[2][2] > -EPS) {res[2][2] = 0.0;}
	res[2][3]  = a[2][0]*b[0][3];
	res[2][3] += a[2][1]*b[1][3];
	res[2][3] += a[2][2]*b[2][3];
	res[2][3] += a[2][3]*b[3][3];
	res[2][3] += a[2][4]*b[4][3];
	res[2][3] += a[2][5]*b[5][3];
	if (res[2][3] < EPS && res[2][3] > -EPS) {res[2][3] = 0.0;}
	res[2][4]  = a[2][0]*b[0][4];
	res[2][4] += a[2][1]*b[1][4];
	res[2][4] += a[2][2]*b[2][4];
	res[2][4] += a[2][3]*b[3][4];
	res[2][4] += a[2][4]*b[4][4];
	res[2][4] += a[2][5]*b[5][4];
	if (res[2][4] < EPS && res[2][4] > -EPS) {res[2][4] = 0.0;}
	res[2][5]  = a[2][0]*b[0][5];
	res[2][5] += a[2][1]*b[1][5];
	res[2][5] += a[2][2]*b[2][5];
	res[2][5] += a[2][3]*b[3][5];
	res[2][5] += a[2][4]*b[4][5];
	res[2][5] += a[2][5]*b[5][5];
	if (res[2][5] < EPS && res[2][5] > -EPS) {res[2][5] = 0.0;}
	res[3][0]  = a[3][0]*b[0][0];
	res[3][0] += a[3][1]*b[1][0];
	res[3][0] += a[3][2]*b[2][0];
	res[3][0] += a[3][3]*b[3][0];
	res[3][0] += a[3][4]*b[4][0];
	res[3][0] += a[3][5]*b[5][0];
	if (res[3][0] < EPS && res[3][0] > -EPS) {res[3][0] = 0.0;}
	res[3][1]  = a[3][0]*b[0][1];
	res[3][1] += a[3][1]*b[1][1];
	res[3][1] += a[3][2]*b[2][1];
	res[3][1] += a[3][3]*b[3][1];
	res[3][1] += a[3][4]*b[4][1];
	res[3][1] += a[3][5]*b[5][1];
	if (res[3][1] < EPS && res[3][1] > -EPS) {res[3][1] = 0.0;}
	res[3][2]  = a[3][0]*b[0][2];
	res[3][2] += a[3][1]*b[1][2];
	res[3][2] += a[3][2]*b[2][2];
	res[3][2] += a[3][3]*b[3][2];
	res[3][2] += a[3][4]*b[4][2];
	res[3][2] += a[3][5]*b[5][2];
	if (res[3][2] < EPS && res[3][2] > -EPS) {res[3][2] = 0.0;}
	res[3][3]  = a[3][0]*b[0][3];
	res[3][3] += a[3][1]*b[1][3];
	res[3][3] += a[3][2]*b[2][3];
	res[3][3] += a[3][3]*b[3][3];
	res[3][3] += a[3][4]*b[4][3];
	res[3][3] += a[3][5]*b[5][3];
	if (res[3][3] < EPS && res[3][3] > -EPS) {res[3][3] = 0.0;}
	res[3][4]  = a[3][0]*b[0][4];
	res[3][4] += a[3][1]*b[1][4];
	res[3][4] += a[3][2]*b[2][4];
	res[3][4] += a[3][3]*b[3][4];
	res[3][4] += a[3][4]*b[4][4];
	res[3][4] += a[3][5]*b[5][4];
	if (res[3][4] < EPS && res[3][4] > -EPS) {res[3][4] = 0.0;}
	res[3][5]  = a[3][0]*b[0][5];
	res[3][5] += a[3][1]*b[1][5];
	res[3][5] += a[3][2]*b[2][5];
	res[3][5] += a[3][3]*b[3][5];
	res[3][5] += a[3][4]*b[4][5];
	res[3][5] += a[3][5]*b[5][5];
	if (res[3][5] < EPS && res[3][5] > -EPS) {res[3][5] = 0.0;}
	res[4][0]  = a[4][0]*b[0][0];
	res[4][0] += a[4][1]*b[1][0];
	res[4][0] += a[4][2]*b[2][0];
	res[4][0] += a[4][3]*b[3][0];
	res[4][0] += a[4][4]*b[4][0];
	res[4][0] += a[4][5]*b[5][0];
	if (res[4][0] < EPS && res[4][0] > -EPS) {res[4][0] = 0.0;}
	res[4][1]  = a[4][0]*b[0][1];
	res[4][1] += a[4][1]*b[1][1];
	res[4][1] += a[4][2]*b[2][1];
	res[4][1] += a[4][3]*b[3][1];
	res[4][1] += a[4][4]*b[4][1];
	res[4][1] += a[4][5]*b[5][1];
	if (res[4][1] < EPS && res[4][1] > -EPS) {res[4][1] = 0.0;}
	res[4][2]  = a[4][0]*b[0][2];
	res[4][2] += a[4][1]*b[1][2];
	res[4][2] += a[4][2]*b[2][2];
	res[4][2] += a[4][3]*b[3][2];
	res[4][2] += a[4][4]*b[4][2];
	res[4][2] += a[4][5]*b[5][2];
	if (res[4][2] < EPS && res[4][2] > -EPS) {res[4][2] = 0.0;}
	res[4][3]  = a[4][0]*b[0][3];
	res[4][3] += a[4][1]*b[1][3];
	res[4][3] += a[4][2]*b[2][3];
	res[4][3] += a[4][3]*b[3][3];
	res[4][3] += a[4][4]*b[4][3];
	res[4][3] += a[4][5]*b[5][3];
	if (res[4][3] < EPS && res[4][3] > -EPS) {res[4][3] = 0.0;}
	res[4][4]  = a[4][0]*b[0][4];
	res[4][4] += a[4][1]*b[1][4];
	res[4][4] += a[4][2]*b[2][4];
	res[4][4] += a[4][3]*b[3][4];
	res[4][4] += a[4][4]*b[4][4];
	res[4][4] += a[4][5]*b[5][4];
	if (res[4][4] < EPS && res[4][4] > -EPS) {res[4][4] = 0.0;}
	res[4][5]  = a[4][0]*b[0][5];
	res[4][5] += a[4][1]*b[1][5];
	res[4][5] += a[4][2]*b[2][5];
	res[4][5] += a[4][3]*b[3][5];
	res[4][5] += a[4][4]*b[4][5];
	res[4][5] += a[4][5]*b[5][5];
	if (res[4][5] < EPS && res[4][5] > -EPS) {res[4][5] = 0.0;}
	res[5][0]  = a[5][0]*b[0][0];
	res[5][0] += a[5][1]*b[1][0];
	res[5][0] += a[5][2]*b[2][0];
	res[5][0] += a[5][3]*b[3][0];
	res[5][0] += a[5][4]*b[4][0];
	res[5][0] += a[5][5]*b[5][0];
	if (res[5][0] < EPS && res[5][0] > -EPS) {res[5][0] = 0.0;}
	res[5][1]  = a[5][0]*b[0][1];
	res[5][1] += a[5][1]*b[1][1];
	res[5][1] += a[5][2]*b[2][1];
	res[5][1] += a[5][3]*b[3][1];
	res[5][1] += a[5][4]*b[4][1];
	res[5][1] += a[5][5]*b[5][1];
	if (res[5][1] < EPS && res[5][1] > -EPS) {res[5][1] = 0.0;}
	res[5][2]  = a[5][0]*b[0][2];
	res[5][2] += a[5][1]*b[1][2];
	res[5][2] += a[5][2]*b[2][2];
	res[5][2] += a[5][3]*b[3][2];
	res[5][2] += a[5][4]*b[4][2];
	res[5][2] += a[5][5]*b[5][2];
	if (res[5][2] < EPS && res[5][2] > -EPS) {res[5][2] = 0.0;}
	res[5][3]  = a[5][0]*b[0][3];
	res[5][3] += a[5][1]*b[1][3];
	res[5][3] += a[5][2]*b[2][3];
	res[5][3] += a[5][3]*b[3][3];
	res[5][3] += a[5][4]*b[4][3];
	res[5][3] += a[5][5]*b[5][3];
	if (res[5][3] < EPS && res[5][3] > -EPS) {res[5][3] = 0.0;}
	res[5][4]  = a[5][0]*b[0][4];
	res[5][4] += a[5][1]*b[1][4];
	res[5][4] += a[5][2]*b[2][4];
	res[5][4] += a[5][3]*b[3][4];
	res[5][4] += a[5][4]*b[4][4];
	res[5][4] += a[5][5]*b[5][4];
	if (res[5][4] < EPS && res[5][4] > -EPS) {res[5][4] = 0.0;}
	res[5][5]  = a[5][0]*b[0][5];
	res[5][5] += a[5][1]*b[1][5];
	res[5][5] += a[5][2]*b[2][5];
	res[5][5] += a[5][3]*b[3][5];
	res[5][5] += a[5][4]*b[4][5];
	res[5][5] += a[5][5]*b[5][5];
	if (res[5][5] < EPS && res[5][5] > -EPS) {res[5][5] = 0.0;}
	memcpy(ab, res, 6*6*sizeof(double));
}

int mat_inv6(double m[6][6], double i[6][6])
{
	double m2[6][6], inv[6][6], f, diag;
	assert(m!=NULL); assert(i!=NULL);
	mat_cpy6(m, m2);
	mat_unity6(inv);
	/* If the diagonal is zero, matrix is not invertable */
	diag = m2[0][0];
	diag *= m2[1][1];
	diag *= m2[2][2];
	diag *= m2[3][3];
	diag *= m2[4][4];
	diag *= m2[5][5];
	if (diag < EPS) {return 1;}
	/* Empty the lower half of the matrix */
	/* Row 1 */
	f = m2[1][0]/m2[0][0];
	m2[1][0] -= f*m2[0][0]; inv[1][0] -= f*inv[0][0];
	m2[1][1] -= f*m2[0][1]; inv[1][1] -= f*inv[0][1];
	m2[1][2] -= f*m2[0][2]; inv[1][2] -= f*inv[0][2];
	m2[1][3] -= f*m2[0][3]; inv[1][3] -= f*inv[0][3];
	m2[1][4] -= f*m2[0][4]; inv[1][4] -= f*inv[0][4];
	m2[1][5] -= f*m2[0][5]; inv[1][5] -= f*inv[0][5];
	f = m2[2][0]/m2[0][0];
	m2[2][0] -= f*m2[0][0]; inv[2][0] -= f*inv[0][0];
	m2[2][1] -= f*m2[0][1]; inv[2][1] -= f*inv[0][1];
	m2[2][2] -= f*m2[0][2]; inv[2][2] -= f*inv[0][2];
	m2[2][3] -= f*m2[0][3]; inv[2][3] -= f*inv[0][3];
	m2[2][4] -= f*m2[0][4]; inv[2][4] -= f*inv[0][4];
	m2[2][5] -= f*m2[0][5]; inv[2][5] -= f*inv[0][5];
	f = m2[3][0]/m2[0][0];
	m2[3][0] -= f*m2[0][0]; inv[3][0] -= f*inv[0][0];
	m2[3][1] -= f*m2[0][1]; inv[3][1] -= f*inv[0][1];
	m2[3][2] -= f*m2[0][2]; inv[3][2] -= f*inv[0][2];
	m2[3][3] -= f*m2[0][3]; inv[3][3] -= f*inv[0][3];
	m2[3][4] -= f*m2[0][4]; inv[3][4] -= f*inv[0][4];
	m2[3][5] -= f*m2[0][5]; inv[3][5] -= f*inv[0][5];
	f = m2[4][0]/m2[0][0];
	m2[4][0] -= f*m2[0][0]; inv[4][0] -= f*inv[0][0];
	m2[4][1] -= f*m2[0][1]; inv[4][1] -= f*inv[0][1];
	m2[4][2] -= f*m2[0][2]; inv[4][2] -= f*inv[0][2];
	m2[4][3] -= f*m2[0][3]; inv[4][3] -= f*inv[0][3];
	m2[4][4] -= f*m2[0][4]; inv[4][4] -= f*inv[0][4];
	m2[4][5] -= f*m2[0][5]; inv[4][5] -= f*inv[0][5];
	f = m2[5][0]/m2[0][0];
	m2[5][0] -= f*m2[0][0]; inv[5][0] -= f*inv[0][0];
	m2[5][1] -= f*m2[0][1]; inv[5][1] -= f*inv[0][1];
	m2[5][2] -= f*m2[0][2]; inv[5][2] -= f*inv[0][2];
	m2[5][3] -= f*m2[0][3]; inv[5][3] -= f*inv[0][3];
	m2[5][4] -= f*m2[0][4]; inv[5][4] -= f*inv[0][4];
	m2[5][5] -= f*m2[0][5]; inv[5][5] -= f*inv[0][5];
	/* Row 2 */
	f = m2[2][1]/m2[1][1];
	m2[2][0] -= f*m2[1][0]; inv[2][0] -= f*inv[1][0];
	m2[2][1] -= f*m2[1][1]; inv[2][1] -= f*inv[1][1];
	m2[2][2] -= f*m2[1][2]; inv[2][2] -= f*inv[1][2];
	m2[2][3] -= f*m2[1][3]; inv[2][3] -= f*inv[1][3];
	m2[2][4] -= f*m2[1][4]; inv[2][4] -= f*inv[1][4];
	m2[2][5] -= f*m2[1][5]; inv[2][5] -= f*inv[1][5];
	f = m2[3][1]/m2[1][1];
	m2[3][0] -= f*m2[1][0]; inv[3][0] -= f*inv[1][0];
	m2[3][1] -= f*m2[1][1]; inv[3][1] -= f*inv[1][1];
	m2[3][2] -= f*m2[1][2]; inv[3][2] -= f*inv[1][2];
	m2[3][3] -= f*m2[1][3]; inv[3][3] -= f*inv[1][3];
	m2[3][4] -= f*m2[1][4]; inv[3][4] -= f*inv[1][4];
	m2[3][5] -= f*m2[1][5]; inv[3][5] -= f*inv[1][5];
	f = m2[4][1]/m2[1][1];
	m2[4][0] -= f*m2[1][0]; inv[4][0] -= f*inv[1][0];
	m2[4][1] -= f*m2[1][1]; inv[4][1] -= f*inv[1][1];
	m2[4][2] -= f*m2[1][2]; inv[4][2] -= f*inv[1][2];
	m2[4][3] -= f*m2[1][3]; inv[4][3] -= f*inv[1][3];
	m2[4][4] -= f*m2[1][4]; inv[4][4] -= f*inv[1][4];
	m2[4][5] -= f*m2[1][5]; inv[4][5] -= f*inv[1][5];
	f = m2[5][1]/m2[1][1];
	m2[5][0] -= f*m2[1][0]; inv[5][0] -= f*inv[1][0];
	m2[5][1] -= f*m2[1][1]; inv[5][1] -= f*inv[1][1];
	m2[5][2] -= f*m2[1][2]; inv[5][2] -= f*inv[1][2];
	m2[5][3] -= f*m2[1][3]; inv[5][3] -= f*inv[1][3];
	m2[5][4] -= f*m2[1][4]; inv[5][4] -= f*inv[1][4];
	m2[5][5] -= f*m2[1][5]; inv[5][5] -= f*inv[1][5];
	/* Row 3 */
	f = m2[3][2]/m2[2][2];
	m2[3][0] -= f*m2[2][0]; inv[3][0] -= f*inv[2][0];
	m2[3][1] -= f*m2[2][1]; inv[3][1] -= f*inv[2][1];
	m2[3][2] -= f*m2[2][2]; inv[3][2] -= f*inv[2][2];
	m2[3][3] -= f*m2[2][3]; inv[3][3] -= f*inv[2][3];
	m2[3][4] -= f*m2[2][4]; inv[3][4] -= f*inv[2][4];
	m2[3][5] -= f*m2[2][5]; inv[3][5] -= f*inv[2][5];
	f = m2[4][2]/m2[2][2];
	m2[4][0] -= f*m2[2][0]; inv[4][0] -= f*inv[2][0];
	m2[4][1] -= f*m2[2][1]; inv[4][1] -= f*inv[2][1];
	m2[4][2] -= f*m2[2][2]; inv[4][2] -= f*inv[2][2];
	m2[4][3] -= f*m2[2][3]; inv[4][3] -= f*inv[2][3];
	m2[4][4] -= f*m2[2][4]; inv[4][4] -= f*inv[2][4];
	m2[4][5] -= f*m2[2][5]; inv[4][5] -= f*inv[2][5];
	f = m2[5][2]/m2[2][2];
	m2[5][0] -= f*m2[2][0]; inv[5][0] -= f*inv[2][0];
	m2[5][1] -= f*m2[2][1]; inv[5][1] -= f*inv[2][1];
	m2[5][2] -= f*m2[2][2]; inv[5][2] -= f*inv[2][2];
	m2[5][3] -= f*m2[2][3]; inv[5][3] -= f*inv[2][3];
	m2[5][4] -= f*m2[2][4]; inv[5][4] -= f*inv[2][4];
	m2[5][5] -= f*m2[2][5]; inv[5][5] -= f*inv[2][5];
	/* Row 4 */
	f = m2[4][3]/m2[3][3];
	m2[4][0] -= f*m2[3][0]; inv[4][0] -= f*inv[3][0];
	m2[4][1] -= f*m2[3][1]; inv[4][1] -= f*inv[3][1];
	m2[4][2] -= f*m2[3][2]; inv[4][2] -= f*inv[3][2];
	m2[4][3] -= f*m2[3][3]; inv[4][3] -= f*inv[3][3];
	m2[4][4] -= f*m2[3][4]; inv[4][4] -= f*inv[3][4];
	m2[4][5] -= f*m2[3][5]; inv[4][5] -= f*inv[3][5];
	f = m2[5][3]/m2[3][3];
	m2[5][0] -= f*m2[3][0]; inv[5][0] -= f*inv[3][0];
	m2[5][1] -= f*m2[3][1]; inv[5][1] -= f*inv[3][1];
	m2[5][2] -= f*m2[3][2]; inv[5][2] -= f*inv[3][2];
	m2[5][3] -= f*m2[3][3]; inv[5][3] -= f*inv[3][3];
	m2[5][4] -= f*m2[3][4]; inv[5][4] -= f*inv[3][4];
	m2[5][5] -= f*m2[3][5]; inv[5][5] -= f*inv[3][5];
	/* Row 5 */
	f = m2[5][4]/m2[4][4];
	m2[5][0] -= f*m2[4][0]; inv[5][0] -= f*inv[4][0];
	m2[5][1] -= f*m2[4][1]; inv[5][1] -= f*inv[4][1];
	m2[5][2] -= f*m2[4][2]; inv[5][2] -= f*inv[4][2];
	m2[5][3] -= f*m2[4][3]; inv[5][3] -= f*inv[4][3];
	m2[5][4] -= f*m2[4][4]; inv[5][4] -= f*inv[4][4];
	m2[5][5] -= f*m2[4][5]; inv[5][5] -= f*inv[4][5];
	/* Now empty the upper half */
	/* Column 5 */
	f = m2[4][5]/m2[5][5];
	inv[4][0] -= f*inv[5][0]; m2[4][0] -= f*m2[5][0];
	inv[4][1] -= f*inv[5][1]; m2[4][1] -= f*m2[5][1];
	inv[4][2] -= f*inv[5][2]; m2[4][2] -= f*m2[5][2];
	inv[4][3] -= f*inv[5][3]; m2[4][3] -= f*m2[5][3];
	inv[4][4] -= f*inv[5][4]; m2[4][4] -= f*m2[5][4];
	inv[4][5] -= f*inv[5][5]; m2[4][5] -= f*m2[5][5];
	f = m2[3][5]/m2[5][5];
	inv[3][0] -= f*inv[5][0]; m2[3][0] -= f*m2[5][0];
	inv[3][1] -= f*inv[5][1]; m2[3][1] -= f*m2[5][1];
	inv[3][2] -= f*inv[5][2]; m2[3][2] -= f*m2[5][2];
	inv[3][3] -= f*inv[5][3]; m2[3][3] -= f*m2[5][3];
	inv[3][4] -= f*inv[5][4]; m2[3][4] -= f*m2[5][4];
	inv[3][5] -= f*inv[5][5]; m2[3][5] -= f*m2[5][5];
	f = m2[2][5]/m2[5][5];
	inv[2][0] -= f*inv[5][0]; m2[2][0] -= f*m2[5][0];
	inv[2][1] -= f*inv[5][1]; m2[2][1] -= f*m2[5][1];
	inv[2][2] -= f*inv[5][2]; m2[2][2] -= f*m2[5][2];
	inv[2][3] -= f*inv[5][3]; m2[2][3] -= f*m2[5][3];
	inv[2][4] -= f*inv[5][4]; m2[2][4] -= f*m2[5][4];
	inv[2][5] -= f*inv[5][5]; m2[2][5] -= f*m2[5][5];
	f = m2[1][5]/m2[5][5];
	inv[1][0] -= f*inv[5][0]; m2[1][0] -= f*m2[5][0];
	inv[1][1] -= f*inv[5][1]; m2[1][1] -= f*m2[5][1];
	inv[1][2] -= f*inv[5][2]; m2[1][2] -= f*m2[5][2];
	inv[1][3] -= f*inv[5][3]; m2[1][3] -= f*m2[5][3];
	inv[1][4] -= f*inv[5][4]; m2[1][4] -= f*m2[5][4];
	inv[1][5] -= f*inv[5][5]; m2[1][5] -= f*m2[5][5];
	f = m2[0][5]/m2[5][5];
	inv[0][0] -= f*inv[5][0]; m2[0][0] -= f*m2[5][0];
	inv[0][1] -= f*inv[5][1]; m2[0][1] -= f*m2[5][1];
	inv[0][2] -= f*inv[5][2]; m2[0][2] -= f*m2[5][2];
	inv[0][3] -= f*inv[5][3]; m2[0][3] -= f*m2[5][3];
	inv[0][4] -= f*inv[5][4]; m2[0][4] -= f*m2[5][4];
	inv[0][5] -= f*inv[5][5]; m2[0][5] -= f*m2[5][5];
	/* Column 4 */
	f = m2[3][4]/m2[4][4];
	inv[3][0] -= f*inv[4][0]; m2[3][0] -= f*m2[4][0];
	inv[3][1] -= f*inv[4][1]; m2[3][1] -= f*m2[4][1];
	inv[3][2] -= f*inv[4][2]; m2[3][2] -= f*m2[4][2];
	inv[3][3] -= f*inv[4][3]; m2[3][3] -= f*m2[4][3];
	inv[3][4] -= f*inv[4][4]; m2[3][4] -= f*m2[4][4];
	inv[3][5] -= f*inv[4][5]; m2[3][5] -= f*m2[4][5];
	f = m2[2][4]/m2[4][4];
	inv[2][0] -= f*inv[4][0]; m2[2][0] -= f*m2[4][0];
	inv[2][1] -= f*inv[4][1]; m2[2][1] -= f*m2[4][1];
	inv[2][2] -= f*inv[4][2]; m2[2][2] -= f*m2[4][2];
	inv[2][3] -= f*inv[4][3]; m2[2][3] -= f*m2[4][3];
	inv[2][4] -= f*inv[4][4]; m2[2][4] -= f*m2[4][4];
	inv[2][5] -= f*inv[4][5]; m2[2][5] -= f*m2[4][5];
	f = m2[1][4]/m2[4][4];
	inv[1][0] -= f*inv[4][0]; m2[1][0] -= f*m2[4][0];
	inv[1][1] -= f*inv[4][1]; m2[1][1] -= f*m2[4][1];
	inv[1][2] -= f*inv[4][2]; m2[1][2] -= f*m2[4][2];
	inv[1][3] -= f*inv[4][3]; m2[1][3] -= f*m2[4][3];
	inv[1][4] -= f*inv[4][4]; m2[1][4] -= f*m2[4][4];
	inv[1][5] -= f*inv[4][5]; m2[1][5] -= f*m2[4][5];
	f = m2[0][4]/m2[4][4];
	inv[0][0] -= f*inv[4][0]; m2[0][0] -= f*m2[4][0];
	inv[0][1] -= f*inv[4][1]; m2[0][1] -= f*m2[4][1];
	inv[0][2] -= f*inv[4][2]; m2[0][2] -= f*m2[4][2];
	inv[0][3] -= f*inv[4][3]; m2[0][3] -= f*m2[4][3];
	inv[0][4] -= f*inv[4][4]; m2[0][4] -= f*m2[4][4];
	inv[0][5] -= f*inv[4][5]; m2[0][5] -= f*m2[4][5];
	/* Column 3 */
	f = m2[2][3]/m2[3][3];
	inv[2][0] -= f*inv[3][0]; m2[2][0] -= f*m2[3][0];
	inv[2][1] -= f*inv[3][1]; m2[2][1] -= f*m2[3][1];
	inv[2][2] -= f*inv[3][2]; m2[2][2] -= f*m2[3][2];
	inv[2][3] -= f*inv[3][3]; m2[2][3] -= f*m2[3][3];
	inv[2][4] -= f*inv[3][4]; m2[2][4] -= f*m2[3][4];
	inv[2][5] -= f*inv[3][5]; m2[2][5] -= f*m2[3][5];
	f = m2[1][3]/m2[3][3];
	inv[1][0] -= f*inv[3][0]; m2[1][0] -= f*m2[3][0];
	inv[1][1] -= f*inv[3][1]; m2[1][1] -= f*m2[3][1];
	inv[1][2] -= f*inv[3][2]; m2[1][2] -= f*m2[3][2];
	inv[1][3] -= f*inv[3][3]; m2[1][3] -= f*m2[3][3];
	inv[1][4] -= f*inv[3][4]; m2[1][4] -= f*m2[3][4];
	inv[1][5] -= f*inv[3][5]; m2[1][5] -= f*m2[3][5];
	f = m2[0][3]/m2[3][3];
	inv[0][0] -= f*inv[3][0]; m2[0][0] -= f*m2[3][0];
	inv[0][1] -= f*inv[3][1]; m2[0][1] -= f*m2[3][1];
	inv[0][2] -= f*inv[3][2]; m2[0][2] -= f*m2[3][2];
	inv[0][3] -= f*inv[3][3]; m2[0][3] -= f*m2[3][3];
	inv[0][4] -= f*inv[3][4]; m2[0][4] -= f*m2[3][4];
	inv[0][5] -= f*inv[3][5]; m2[0][5] -= f*m2[3][5];
	/* Column 2 */
	f = m2[1][2]/m2[2][2];
	inv[1][0] -= f*inv[2][0]; m2[1][0] -= f*m2[2][0];
	inv[1][1] -= f*inv[2][1]; m2[1][1] -= f*m2[2][1];
	inv[1][2] -= f*inv[2][2]; m2[1][2] -= f*m2[2][2];
	inv[1][3] -= f*inv[2][3]; m2[1][3] -= f*m2[2][3];
	inv[1][4] -= f*inv[2][4]; m2[1][4] -= f*m2[2][4];
	inv[1][5] -= f*inv[2][5]; m2[1][5] -= f*m2[2][5];
	f = m2[0][2]/m2[2][2];
	inv[0][0] -= f*inv[2][0]; m2[0][0] -= f*m2[2][0];
	inv[0][1] -= f*inv[2][1]; m2[0][1] -= f*m2[2][1];
	inv[0][2] -= f*inv[2][2]; m2[0][2] -= f*m2[2][2];
	inv[0][3] -= f*inv[2][3]; m2[0][3] -= f*m2[2][3];
	inv[0][4] -= f*inv[2][4]; m2[0][4] -= f*m2[2][4];
	inv[0][5] -= f*inv[2][5]; m2[0][5] -= f*m2[2][5];
	/* Column 1 */
	f = m2[0][1]/m2[1][1];
	inv[0][0] -= f*inv[1][0]; m2[0][0] -= f*m2[1][0];
	inv[0][1] -= f*inv[1][1]; m2[0][1] -= f*m2[1][1];
	inv[0][2] -= f*inv[1][2]; m2[0][2] -= f*m2[1][2];
	inv[0][3] -= f*inv[1][3]; m2[0][3] -= f*m2[1][3];
	inv[0][4] -= f*inv[1][4]; m2[0][4] -= f*m2[1][4];
	inv[0][5] -= f*inv[1][5]; m2[0][5] -= f*m2[1][5];
	/* Correct the magnitude of the rows */
	inv[0][0] /= m2[0][0];
	inv[0][1] /= m2[0][0];
	inv[0][2] /= m2[0][0];
	inv[0][3] /= m2[0][0];
	inv[0][4] /= m2[0][0];
	inv[0][5] /= m2[0][0];
	inv[1][0] /= m2[1][1];
	inv[1][1] /= m2[1][1];
	inv[1][2] /= m2[1][1];
	inv[1][3] /= m2[1][1];
	inv[1][4] /= m2[1][1];
	inv[1][5] /= m2[1][1];
	inv[2][0] /= m2[2][2];
	inv[2][1] /= m2[2][2];
	inv[2][2] /= m2[2][2];
	inv[2][3] /= m2[2][2];
	inv[2][4] /= m2[2][2];
	inv[2][5] /= m2[2][2];
	inv[3][0] /= m2[3][3];
	inv[3][1] /= m2[3][3];
	inv[3][2] /= m2[3][3];
	inv[3][3] /= m2[3][3];
	inv[3][4] /= m2[3][3];
	inv[3][5] /= m2[3][3];
	inv[4][0] /= m2[4][4];
	inv[4][1] /= m2[4][4];
	inv[4][2] /= m2[4][4];
	inv[4][3] /= m2[4][4];
	inv[4][4] /= m2[4][4];
	inv[4][5] /= m2[4][4];
	inv[5][0] /= m2[5][5];
	inv[5][1] /= m2[5][5];
	inv[5][2] /= m2[5][5];
	inv[5][3] /= m2[5][5];
	inv[5][4] /= m2[5][5];
	inv[5][5] /= m2[5][5];
	mat_cpy6(inv, i);
	return 0;
}

void mat_print6(char *name, double m[6][6])
{
	printf("matrix %s =\n", name);
	printf("|%g %g %g %g %g %g|\n", m[0][0], m[0][1], m[0][2], m[0][3], m[0][4], m[0][5]);
	printf("|%g %g %g %g %g %g|\n", m[1][0], m[1][1], m[1][2], m[1][3], m[1][4], m[1][5]);
	printf("|%g %g %g %g %g %g|\n", m[2][0], m[2][1], m[2][2], m[2][3], m[2][4], m[2][5]);
	printf("|%g %g %g %g %g %g|\n", m[3][0], m[3][1], m[3][2], m[3][3], m[3][4], m[3][5]);
	printf("|%g %g %g %g %g %g|\n", m[4][0], m[4][1], m[4][2], m[4][3], m[4][4], m[4][5]);
	printf("|%g %g %g %g %g %g|\n", m[5][0], m[5][1], m[5][2], m[5][3], m[5][4], m[5][5]);
}
/* EOF matrix6.c */
